package edu.uiuc.dsi.mutex;

import edu.uiuc.dsi.TCPSocket;
import edu.uiuc.dsi.clocks.LamportClock;



public class LamportQueueElement implements Comparable<LamportQueueElement> 
{
	private LamportClock objClock;
	private TCPSocket objSiteTCPSocket;
	
	public LamportQueueElement(short timestamp, TCPSocket objTCPSocket)
	{
		objClock = new LamportClock(timestamp);
		objSiteTCPSocket = objTCPSocket;
	}
	
	public short getTimestamp()
	{
		return objClock.getCurrentTime();
	}
	
	public TCPSocket getSiteTCPSocket()
	{
		return objSiteTCPSocket;
	}

	@Override
	public int compareTo(LamportQueueElement o)
	{
		if (objClock.compareTo(o.objClock) == 0)
			return this.getSiteTCPSocket().compareTo(o.getSiteTCPSocket());
		else
			return objClock.compareTo(o.objClock);
	}
}
